/*
 * MemoryCache.java - Define MemoryCache class,
 * which implements cache at heap.
 * Copyright (C) 2010 Vasily Eremenko <vas@davimas.name>
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

import java.util.*;

public class MemoryCache
{
    private int maxSize;
    private TreeMap<String, Object> heap;

    public MemoryCache(int limit) {
	maxSize = limit;
	heap = new TreeMap<String, Object>();
    } // MemoryCache()

    public void AddObject(Object item, String key)
	throws RuntimeException
    {
	if( heap.size() == maxSize ) {
	    throw new RuntimeException("Memory Cache limit exceeded!");
	}
	heap.put(key, item);
    } // AddObject()

    public Object GetObject(String key)
	throws RuntimeException
    {
	Object item = heap.get(key);
	if(item == null)
	{
	    throw new RuntimeException("No such label in cache!");
	}
	return item;
    } // GetObject()
} // class MemoryCache