/*
 * MemoryCacheTest.java - Define MemoryCacheTest class,
 * which tests MemoryCache class.
 * Copyright (C) 2010 Vasily Eremenko <vas@davimas.name>
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

public class MemoryCacheTest
{
    public static void main(String[] args)
    {
	System.out.println("Creating cache");
	MemoryCache myCache = new MemoryCache(2);

	System.out.println("Adding CachingClass object with magicNumber 3 to cache with label \"third\".");
	CachingClass obj = new CachingClass();
	obj.SetMagicNumber(3);
	myCache.AddObject(obj, "third");
	System.out.println("Forget about object labeled third.");
	obj = null;

	System.out.println("Adding CachingClass object with magicNumber 1 to cache with label \"first\".");
	obj = new CachingClass();
	obj.SetMagicNumber(1);
	myCache.AddObject(obj, "first");
	System.out.println("Forget about object labeled first.");
	obj = null;

	System.out.println("Testing exception throwing when limit reached.");
	obj = new CachingClass();
	obj.SetMagicNumber(2);
	try
	{
	    myCache.AddObject(obj, "second");
	}
	catch(RuntimeException e)
	{
	    System.out.println("RuntimeEception catched. All right! PASSED!");
	}
	System.out.println("Forget about object for limit testing.");
	obj = null;

	System.out.println("Taking from cache object labeled \"first\".");
	obj = (CachingClass) myCache.GetObject("first");
	System.out.println("toString() returns: " + obj.toString());
	System.out.println("Forget about object labeled first.");
	obj = null;
    } // main()
} // class MemoryCacheTest